﻿--settings---------
local x = 0
local y = 200
-------------------
local pName = UnitName("player")
local L = "Trickster"

local DBdefaults = {
	version = 1.2,
	ttext = 1,
	sound = 1,
	fontsize = 24,
}
local TricksterDB 

local Trickster = CreateFrame("Frame", nil, UIParent)
Trickster:SetPoint("CENTER", UIParent, "CENTER", x, y)
Trickster:SetHeight(30)
Trickster:SetWidth(250)

local bg = Trickster:CreateTexture(nil, "BACKGROUND")
bg:SetAllPoints(Trickster)
bg:SetTexture(0.3, 0.3, 0.3, 0.6)
bg:Hide()

local TFont =  Trickster:CreateFontString(nil, "OVERLAY")
TFont:SetPoint("CENTER", Trickster, "CENTER")
TFont:SetFont("Fonts\\FRIZQT__.TTF", 24, "OUTLINE")
TFont:SetTextColor(1,1,1)

function Trickster:OnEvent(event, ...)
	self[event](self, ...)
end
Trickster:SetScript("OnEvent", Trickster.OnEvent)

function Trickster:ADDON_LOADED(arg1) 
	if arg1 == L then
		if _G.TricksterDB then
			--
		else
			_G.TricksterDB = CopyTable(DBdefaults)
		end
		TricksterDB = _G.TricksterDB
	end	
end

function Trickster:COMBAT_LOG_EVENT_UNFILTERED(timestamp, type, _, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool)

	if spellId==57933 then
		if type=="SPELL_AURA_APPLIED" and destName == pName then
			if TricksterDB.sound then 
				PlaySoundFile("Interface\\AddOns\\Trickster\\alert.mp3", "Master") 
			end
			if TricksterDB.ttext then
				TFont:SetText("Tricked by |cffff0000" .. sourceName .. "|r")
			end
		elseif type=="SPELL_AURA_REMOVED" then
			TFont:SetText("")
		end
	end
end

Trickster:RegisterEvent("ADDON_LOADED")
Trickster:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
Trickster:RegisterEvent("PLAYER_LOGOUT")
-------------------------------------------------------------------------------
local O = L .. "OptionsPanel"

local OptionsPanel = CreateFrame("Frame", O)
OptionsPanel.name = L

local title = OptionsPanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
title:SetText(L)

local subText = OptionsPanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
local notes = GetAddOnMetadata(L, "Notes-" .. GetLocale())
if not notes then
	notes = GetAddOnMetadata(L, "Notes")
end
subText:SetText(notes)

local TrickTtext = CreateFrame("CheckButton", O.."TrickTtext", OptionsPanel, "OptionsCheckButtonTemplate")
_G[O.."TrickTtextText"]:SetText("Text announce")
TrickTtext:SetScript("OnClick", function(self)
	TricksterDB.ttext = self:GetChecked()
end)

local TrickSound = CreateFrame("CheckButton", O.."TrickSound", OptionsPanel, "OptionsCheckButtonTemplate")
_G[O.."TrickSoundText"]:SetText("Sound announce")
TrickSound:SetScript("OnClick", function(self)
	TricksterDB.sound = self:GetChecked()
end)

title:SetPoint("TOPLEFT", 16, -16)
subText:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 0, -8)
TrickTtext:SetPoint("TOPLEFT", subText, "BOTTOMLEFT", 0, -12)
TrickSound:SetPoint("TOPLEFT", TrickTtext, "BOTTOMLEFT", 0, -4)

OptionsPanel.default = function()
	_G.TricksterDB = nil
	Trickster:ADDON_LOADED(L)
end

OptionsPanel.refresh = function()
	TrickTtext:SetChecked(TricksterDB.ttext)
	TrickSound:SetChecked(TricksterDB.sound)
end

InterfaceOptions_AddCategory(OptionsPanel)

SLASH_TRICKSTER1 = "/trickster"
SlashCmdList["TRICKSTER"] = function(cmd)
	InterfaceOptionsFrame_OpenToCategory(OptionsPanel)
end